
#ifndef __DEMO_ENTITY_H
#define __DEMO_ENTITY_H

#include "Scenario.h"

class CDemoTime;


class IDemoEntity {
public:
	virtual ~IDemoEntity() { }

	virtual bool isActive( CScenario::eScene scene ) const = 0;
	virtual void onSceneStart( CScenario::eScene scene ) = 0;
	virtual void onSceneEnd( CScenario::eScene scene ) = 0;

	virtual void beforeRendering() = 0;
	virtual void update() = 0;
};


class CDemoEntityAdapter : public IDemoEntity {
public:
	virtual bool isActive( CScenario::eScene scene ) const { return true; };
	virtual void onSceneStart( CScenario::eScene scene ) { };
	virtual void onSceneEnd( CScenario::eScene scene ) { };

	virtual void beforeRendering() { };
	virtual void update() { };
};


class CDemoEntityContainer : public IDemoEntity {
public:
	void addEntity( IDemoEntity& o ) { mEntities.push_back( &o ); }
	void removeEntity( IDemoEntity& o ) { mEntities.remove( &o ); }

	virtual bool isActive( CScenario::eScene scene ) const { return true; };
	virtual void onSceneStart( CScenario::eScene scene );
	virtual void onSceneEnd( CScenario::eScene scene );

	virtual void beforeRendering();
	virtual void update();

private:
	typedef std::list<IDemoEntity*>	TDemoEntityList;
private:
	TDemoEntityList	mEntities;
};


#endif
