#ifndef __GRAY_LINES_H
#define __GRAY_LINES_H

#include "../DemoEntity.h"
#include "../../engine/Line.h"
#include "../../engine/LineRenderer.h"

class CCamera;


class CGrayLinesEntity : public IDemoEntity {
public:
	enum { MAX_LINES = 100 };

public:
	CGrayLinesEntity( const CCamera& camera );
	virtual ~CGrayLinesEntity();

public:
	virtual bool isActive( CScenario::eScene scene ) const;
	virtual void onSceneStart( CScenario::eScene scene );
	virtual void onSceneEnd( CScenario::eScene scene );
	virtual void update();
	virtual void beforeRendering() { };

private:
	void	updateSceneLines();
	void	updateSceneFade();

private:
	CLineRenderer*	mLineRenderer;

	TLinePool		mLinePool;
};

#endif
