#ifndef __RED_BLOB_H
#define __RED_BLOB_H

#include "../DemoEntity.h"
#include "../../engine/DXObject.h"
#include "../../engine/Vertices.h"

class CFrameTime;

class CRedBlobEntity : public CDXObject, public IDemoEntity {
public:
	enum { MY_FVF = FVF_XYZ_DIFFUSE_TEX1 };
	typedef SVertexXyzDiffuseTex1 TMyVertex;
public:
	CRedBlobEntity();
	virtual ~CRedBlobEntity();

	// CDXObject
	virtual void render( CFrameTime const& frameTime );
	virtual HRESULT onLostDevice();
	virtual HRESULT onResetDevice();

	// IDemoEntity
	virtual bool isActive( CScenario::eScene scene ) const;
	virtual void onSceneStart( CScenario::eScene scene );
	virtual void onSceneEnd( CScenario::eScene scene );
	virtual void update();
	virtual void beforeRendering();

private:
	ID3DXMesh*		mMesh;
	int				mVertexCount;
	int				mTriCount;
	D3DXVECTOR3*	mOriginal;
};

#endif
