#ifndef __WHEEL_H
#define __WHEEL_H

#include "../DemoEntity.h"
#include "../../engine/Line.h"
#include "../../engine/LineRenderer.h"

class CCamera;


class CWheelEntity : public IDemoEntity {
public:
	enum { MAX_LINES = 160 };

public:
	CWheelEntity( const CCamera& camera );
	virtual ~CWheelEntity();

public:
	virtual bool isActive( CScenario::eScene scene ) const;
	virtual void onSceneStart( CScenario::eScene scene );
	virtual void onSceneEnd( CScenario::eScene scene );
	virtual void update();
	virtual void beforeRendering() { };

private:
	void	updateSceneCircle();
	void	updateSceneWheel();
	void	updateSceneFade();

	void	setupWheel();

private:
	CLineRenderer*	mLineRenderer;

	TLinePool		mLinePool;
	float			mRadius;
	float			mWidth;
	float			mHoleAmount;
	float			mRot;
};

#endif
