#ifndef __WHITE_LINES_H
#define __WHITE_LINES_H

#include "../DemoEntity.h"
#include "../../engine/Line.h"
#include "../../engine/LineRenderer.h"
#include "../../utils/Perlin.h"

class CCamera;


class CWhiteLinesEntity : public IDemoEntity {
public:
	enum { MAX_LINES = 120 };

public:
	CWhiteLinesEntity( const CCamera& camera );
	virtual ~CWhiteLinesEntity();

public:
	virtual bool isActive( CScenario::eScene scene ) const;
	virtual void onSceneStart( CScenario::eScene scene );
	virtual void onSceneEnd( CScenario::eScene scene );
	virtual void update();
	virtual void beforeRendering() { };

private:
	void	updateSceneWhiteline();
	void	updateSceneLines();
	void	updateSceneCircle();

private:
	CLineRenderer*	mLineRenderer;

	TLinePool		mLinePool;
	CPerlin			mPerlin;
};

#endif
