#ifndef __APP_CONTEXT_H
#define __APP_CONTEXT_H

class CFrameTime;


class CAppContext {
public:
	CAppContext( CFrameTime& time ) : mWindowAspect( 1.0f ), mTime(&time) {}

	float getWindowAspect() const { return mWindowAspect; }
	const std::string&	getFPS() const { return mFPS; }
	const std::string&	getDeviceInfo() const { return mDeviceInfo; }
	const CFrameTime&	getTime() const { return *mTime; }
	CFrameTime&	getTime() { return *mTime; }

	void setInfo( float windowAspect, const std::string& fps, const std::string& deviceInfo ) {
		mWindowAspect = windowAspect;
		mFPS = fps;
		mDeviceInfo = deviceInfo;
	}

private:
	float				mWindowAspect;
	std::string			mFPS;
	std::string			mDeviceInfo;
	CFrameTime*			mTime;
};

#endif
