#ifndef __DEMO_APP_H
#define __DEMO_APP_H

#include "AppContext.h"
#include "FrameTime.h"

class CConfig;
class CBaseDemo;


class CDemoApp : public CD3DApplication {
public:
    CDemoApp( CBaseDemo& demo, CConfig& config );
	~CDemoApp();
	
    virtual HRESULT OneTimeSceneInit();
    virtual HRESULT InitDeviceObjects();
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();
    virtual HRESULT FrameMove();
    virtual HRESULT Render();
	
    virtual LRESULT MsgProc( HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam );

private:
	CBaseDemo&	mDemo;
	CConfig&	mConfig;

	CFrameTime	mFrameTime;

	CAppContext	mAppContext;
	bool		mWindowed;
};

#endif
