
#ifndef __LINE_RENDERER_H
#define __LINE_RENDERER_H

#include "Line.h"
#include "DXObject.h"
#include "../common/resource/ResourceId.h"


class CCamera;
class CFrameTime;
struct SVertexXyzDiffuseTex1;


class CLineRenderer : public CDXObject {
public:
	CLineRenderer( CCamera const& camera, const CResourceId& effectId, const CResourceId& textureId, const TLinePool& lines );
	virtual ~CLineRenderer();
	
	virtual HRESULT onCreateDevice( IDirect3DDevice8* device );
	virtual HRESULT onLostDevice();
	virtual HRESULT onResetDevice();
	virtual HRESULT onDestroyDevice();

	virtual void render( CFrameTime const& frameTime );

private:
	IDirect3DIndexBuffer8*	mIB;
	IDirect3DVertexBuffer8*	mVB;
	int						mBufferPosition;

	CCamera const&			mCamera;
	CResourceId				mEffectId;
	CResourceId				mTextureId;
	const TLinePool&		mLines;
};

#endif
